# Encabezado para poder utilizar las funciones de BLT
package require BLT
namespace import blt::*

# Esta es la parte de control de desplegado de la matrix
proc matrix_1 {win x0 x1} {
   catch {eventos_matrix_1 $win x_menos5}
   catch {eventos_matrix_1 $win x_menos1}
   catch {eventos_matrix_1 $win x_mas1}
   catch {eventos_matrix_1 $win x_mas5}
   catch {eventos_change_table_1 $win Aceptar}
   catch {eventos_change_table_1 $win Aplicar}
   catch {eventos_change_table_1 $win Cancelar}
   toplevel .$win
   global min_x
   global max_x
   global x_min
   global x_max
   global matrix_backup
   global vt_e
   set min_x $x0
   set max_x $x1
   set x_min 0
   set x_max 5
   set matrix_backup(0) 0
   set vt_e(0) 0
   for {set i $min_x} {$i < $max_x} {incr i 1} {
      set matrix_backup($i) $i 
   }
   frame .$win.fr0
   pack  .$win.fr0
   frame .$win.fr0.fr0
   frame .$win.fr0.fr1
   table .$win.fr0 \
      0,0 .$win.fr0.fr0 \
      1,0 .$win.fr0.fr1
   label .$win.fr0.fr0.lb0 -text $win
   table .$win.fr0.fr0 \
      1,0 .$win.fr0.fr0.lb0
   for {set i 0} {$i < 5} {incr i 1} {
      label .$win.fr0.fr0.xlb$i -text $i
      table .$win.fr0.fr0 \
         0,[expr $i-$x_min+1] .$win.fr0.fr0.xlb$i
   }
   for {set i 0} {$i < 5} {incr i 1} {
      entry .$win.fr0.fr0.e$i -width 10 -textvariable vt_e($i)
      set vt_e($i) $matrix_backup($i)
      table .$win.fr0.fr0 \
         1,[expr $i-$x_min+1] .$win.fr0.fr0.e$i
   }
   button .$win.fr0.fr1.b0 -text "<<" -command "eventos_matrix_1 $win x_menos5" -relief flat
   button .$win.fr0.fr1.b1 -text "< " -command "eventos_matrix_1 $win x_menos1" -relief flat
   button .$win.fr0.fr1.b2 -text " >" -command "eventos_matrix_1 $win x_mas1"   -relief flat
   button .$win.fr0.fr1.b3 -text ">>" -command "eventos_matrix_1 $win x_mas5"   -relief flat
   table .$win.fr0.fr1 \
      0,1 .$win.fr0.fr1.b0 \
      0,2 .$win.fr0.fr1.b1 \
      0,3 .$win.fr0.fr1.b2 \
      0,4 .$win.fr0.fr1.b3
   button .$win.fr0.fr1.b4 -text Acept  -command "eventos_change_table_1 $win Aceptar"
   button .$win.fr0.fr1.b5 -text Apply  -command "eventos_change_table_1 $win Aplicar"
   button .$win.fr0.fr1.b6 -text Cancel -command "eventos_change_table_1 $win Cancelar"
   label .$win.fr0.fr1.lb0 -text "   "
   label .$win.fr0.fr1.lb1 -text "   "
   table .$win.fr0.fr1 \
      0,5 .$win.fr0.fr1.lb0 \
      0,6 .$win.fr0.fr1.lb1 \
      0,7 .$win.fr0.fr1.b4 \
      0,8 .$win.fr0.fr1.b5 \
      0,9 .$win.fr0.fr1.b6
 }

# Esta es la parte de control de los eventos que ocurren en la matrix
proc eventos_matrix_1 {win action} {
   global min_x
   global max_x
   global x_min
   global x_max
   global matrix_backup
   global vt_e
   for {set i $x_min} {$i < $x_max} {incr i 1} {
      set matrix_backup($i) [.$win.fr0.fr0.e[expr $i-$x_min] get]
   }
   if {![string compare $action x_mas5]} {
      if {$x_max < [expr $max_x-4]} {
      	 incr x_min 5
         incr x_max 5
      }
   } elseif {![string compare $action x_menos5]} {
        if {$x_min > [expr $min_x+4]} {
           incr x_min -5
           incr x_max -5
   	}
     } elseif {![string compare $action x_mas1]} {
          if {$x_max < $max_x} {
             incr x_min 1
             incr x_max 1
          }
       } elseif {![string compare $action x_menos1]} {
            if {$x_min > $min_x} {
               incr x_min -1
               incr x_max -1
            }
         }
   for {set i $x_min} {$i < $x_max} {incr i 1} {
      .$win.fr0.fr0.xlb[expr $i-$x_min] configure -text $i
   }
   for {set i $x_min} {$i < $x_max} {incr i 1} {
      set vt_e([expr $i-$x_min]) $matrix_backup($i)
   }
}

proc eventos_change_table_1 {win action} {
   global min_x
   global max_x
   global x_min
   global x_max
   global matrix_backup
   global vt_e
   if {![string compare $action Aceptar]} {
      for {set i $x_min} {$i < $x_max} {incr i 1} {
         set matrix_backup($i) [.$win.fr0.fr0.e[expr $i-$x_min] get]
      }
      enviar_matrix_1
      destroy .$win
      unset min_x
      unset max_x
      unset x_min
      unset x_max
      unset matrix_backup
      unset vt_e
   } elseif {![string compare $action Aplicar]} {
        for {set i $x_min} {$i < $x_max} {incr i 1} {
           set matrix_backup($i) [.$win.fr0.fr0.e[expr $i-$x_min] get]
        }
        enviar_matrix_1
     } elseif {![string compare $action Cancelar]} {
          destroy .$win
          unset min_x
          unset max_x
          unset x_min
          unset x_max
          unset matrix_backup
          unset vt_e
       }
}

proc enviar_matrix_1 {} {
   global min_x
   global max_x
   global matrix_backup
   for {set i $min_x} {$i < $max_x} {incr i 1} {
      set str "envio ($i) $matrix_backup($i)"
      puts $str
   }
}