# Encabezado para poder utilizar las funciones de BLT
package require BLT
namespace import blt::*

# Esta es la parte de control de desplegado de la matrix
proc matrix_4 {win x0 x1 y0 y1 z0 z1 w0 w1} {
   catch {eventos_motion_matrix_4 $win x_menos5}
   catch {eventos_motion_matrix_4 $win x_menos1}
   catch {eventos_motion_matrix_4 $win x_mas1}
   catch {eventos_motion_matrix_4 $win x_mas5}
   catch {eventos_motion_matrix_4 $win y_menos5}
   catch {eventos_motion_matrix_4 $win y_menos1}
   catch {eventos_motion_matrix_4 $win y_mas1}
   catch {eventos_motion_matrix_4 $win y_mas5}
   catch {eventos_motion_matrix_4 $win z_menos5}
   catch {eventos_motion_matrix_4 $win z_menos1}
   catch {eventos_motion_matrix_4 $win z_mas1}
   catch {eventos_motion_matrix_4 $win z_mas5}
   catch {eventos_change_table_4 $win z_bcm_0}
   catch {eventos_change_table_4 $win z_bcm_1}
   catch {eventos_change_table_4 $win z_bcm_2}
   catch {eventos_change_table_4 $win z_bcm_3}
   catch {eventos_change_table_4 $win z_bcm_4}
   catch {eventos_motion_matrix_4 $win w_menos5}
   catch {eventos_motion_matrix_4 $win w_menos1}
   catch {eventos_motion_matrix_4 $win w_mas1}
   catch {eventos_motion_matrix_4 $win w_mas5}
   catch {eventos_change_table_4 $win w_bcm_0}
   catch {eventos_change_table_4 $win w_bcm_1}
   catch {eventos_change_table_4 $win w_bcm_2}
   catch {eventos_change_table_4 $win w_bcm_3}
   catch {eventos_change_table_4 $win w_bcm_4}
   catch {eventos_change_table $win Aceptar}
   catch {eventos_change_table $win Aplicar}
   catch {eventos_change_table $win Cancelar}
   toplevel .$win  
   global min_x
   global max_x
   global min_y
   global max_y
   global min_z
   global max_z
   global min_w
   global max_w
   global x_min
   global x_max
   global y_min
   global y_max
   global z_min
   global z_max
   global w_min
   global w_max
   global z_index
   global w_index
   global matrix_backup
   global vt_e
   set min_x $x0
   set max_x $x1
   set min_y $y0
   set max_y $y1
   set min_z $z0
   set max_z $z1
   set min_w $w0
   set max_w $w1
   set matrix_backup(0,0,0) 0
   set vt_e(0,0) 0
   set x_min 0
   set x_max 5
   set y_min 0
   set y_max 5
   set z_min 0
   set z_max 5
   set w_min 0
   set w_max 5
   set z_index 0
   set w_index 0
# Aqui hay que poner la instruccion de ir por info a Nsl
   for {set l $min_w} {$l < $max_w} {incr l 1} {
      for {set k $min_z} {$k < $max_z} {incr k 1} {
         for {set j $min_y} {$j < $max_y} {incr j 1} {
            for {set i $min_x} {$i < $max_x} {incr i 1} {
               set matrix_backup($i,$j,$k,$l) $i
            }
         }
      }
   }
   frame .$win.fr0
   pack .$win.fr0
   frame .$win.fr0.fr0
   frame .$win.fr0.fr1
   frame .$win.fr0.fr2
   frame .$win.fr0.fr3
   frame .$win.fr0.fr4
   table .$win.fr0 \
      0,0 .$win.fr0.fr0 \
      1,0 .$win.fr0.fr1 \
      2,0 .$win.fr0.fr2 \
      1,1 .$win.fr0.fr3 \
      3,0 .$win.fr0.fr4

   button .$win.fr0.fr0.br5 -text "<<" -command "eventos_motion_matrix_4 $win z_menos5" -relief flat
   button .$win.fr0.fr0.br1 -text "< " -command "eventos_motion_matrix_4 $win z_menos1" -relief flat
   table .$win.fr0.fr0 \
      0,0 .$win.fr0.fr0.br5 \
      0,1 .$win.fr0.fr0.br1
   for {set i $z_min} {$i < $z_max} {incr i 1} {
      button .$win.fr0.fr0.b$i -text $i -command "eventos_change_table_4 $win z_bcm_$i" -relief flat
      table .$win.fr0.fr0 \
         0,[expr $i-$z_min+2] .$win.fr0.fr0.b$i
   }
   button .$win.fr0.fr0.ba1 -text " >" -command "eventos_motion_matrix_4 $win z_mas1" -relief flat
   button .$win.fr0.fr0.ba5 -text ">>" -command "eventos_motion_matrix_4 $win z_mas5" -relief flat
   table .$win.fr0.fr0 \
      0,7 .$win.fr0.fr0.ba1 \
      0,8 .$win.fr0.fr0.ba5

   button .$win.fr0.fr4.br5 -text "<<" -command "eventos_motion_matrix_4 $win w_menos5" -relief flat
   button .$win.fr0.fr4.br1 -text "< " -command "eventos_motion_matrix_4 $win w_menos1" -relief flat
   table .$win.fr0.fr4 \
      0,0 .$win.fr0.fr4.br5 \
      0,1 .$win.fr0.fr4.br1
   for {set i $w_min} {$i < $w_max} {incr i 1} {
      button .$win.fr0.fr4.b$i -text $i -command "eventos_change_table_4 $win w_bcm_$i" -relief flat
      table .$win.fr0.fr4 \
         0,[expr $i-$w_min+2] .$win.fr0.fr4.b$i
   }
   button .$win.fr0.fr4.ba1 -text " >" -command "eventos_motion_matrix_4 $win w_mas1" -relief flat
   button .$win.fr0.fr4.ba5 -text ">>" -command "eventos_motion_matrix_4 $win w_mas5" -relief flat
   table .$win.fr0.fr4 \
      0,7 .$win.fr0.fr4.ba1 \
      0,8 .$win.fr0.fr4.ba5
   
   label .$win.fr0.fr1.lb0 -text "$win 0 0"
   table .$win.fr0.fr1 \
      0,0 .$win.fr0.fr1.lb0
   for {set i 0} {$i < 5} {incr i 1} {
      label .$win.fr0.fr1.xlb$i -text $i
      table .$win.fr0.fr1 \
         0,[expr $i-$x_min+1] .$win.fr0.fr1.xlb$i
   }
   for {set i 0} {$i < 5} {incr i 1} {
      label .$win.fr0.fr1.ylb$i -text $i
      table .$win.fr0.fr1 \
         [expr $i-$y_min+1],0 .$win.fr0.fr1.ylb$i
   }
   for {set j 0} {$j < 5} {incr j 1} {
      for {set i 0} {$i < 5} {incr i 1} {
         entry .$win.fr0.fr1.e($i+$j) -width 10 -textvariable vt_e($i,$j)
         set vt_e($i,$j) $matrix_backup($i,$j,$z_index,$w_index)
         table .$win.fr0.fr1 \
            [expr $j-$y_min+1],[expr $i-$x_min+1] .$win.fr0.fr1.e($i+$j)
      }
   }
   button .$win.fr0.fr2.b0 -text "<<" -command "eventos_motion_matrix_4 $win x_menos5" -relief flat
   button .$win.fr0.fr2.b1 -text "< " -command "eventos_motion_matrix_4 $win x_menos1" -relief flat
   button .$win.fr0.fr2.b2 -text " >" -command "eventos_motion_matrix_4 $win x_mas1"   -relief flat
   button .$win.fr0.fr2.b3 -text ">>" -command "eventos_motion_matrix_4 $win x_mas5"   -relief flat
   table .$win.fr0.fr2 \
      0,1 .$win.fr0.fr2.b0 \
      0,2 .$win.fr0.fr2.b1 \
      0,3 .$win.fr0.fr2.b2 \
      0,4 .$win.fr0.fr2.b3
   button .$win.fr0.fr3.b0 -text "<<" -command "eventos_motion_matrix_4 $win y_menos5" -relief flat
   button .$win.fr0.fr3.b1 -text "< " -command "eventos_motion_matrix_4 $win y_menos1" -relief flat
   button .$win.fr0.fr3.b2 -text " >" -command "eventos_motion_matrix_4 $win y_mas1"   -relief flat
   button .$win.fr0.fr3.b3 -text ">>" -command "eventos_motion_matrix_4 $win y_mas5"   -relief flat
   table .$win.fr0.fr3 \
      4,0 .$win.fr0.fr3.b0 \
      5,0 .$win.fr0.fr3.b1 \
      6,0 .$win.fr0.fr3.b2 \
      7,0 .$win.fr0.fr3.b3
   button .$win.fr0.fr2.b4 -text Acept  -command "eventos_change_table_4 $win Aceptar"
   button .$win.fr0.fr2.b5 -text Apply  -command "eventos_change_table_4 $win Aplicar"
   button .$win.fr0.fr2.b6 -text Cancel -command "eventos_change_table_4 $win Cancelar"
   label .$win.fr0.fr2.lb0 -text "   "
   label .$win.fr0.fr2.lb1 -text "   "
   table .$win.fr0.fr2 \
      0,5 .$win.fr0.fr2.lb0 \
      0,6 .$win.fr0.fr2.lb1 \
      0,7 .$win.fr0.fr2.b4 \
      0,8 .$win.fr0.fr2.b5 \
      0,9 .$win.fr0.fr2.b6
}

# Esta es la parte de control de los eventos que ocurren en la matrix
proc eventos_motion_matrix_4 {win action} {
   global min_x
   global max_x
   global min_y
   global max_y
   global min_z
   global max_z
   global min_w
   global max_w
   global x_min
   global x_max
   global y_min
   global y_max
   global z_min
   global z_max
   global w_min
   global w_max
   global z_index
   global w_index
   global matrix_backup
   global vt_e
   cambiar_matrix_4 $win 0 -1
   if {![string compare $action x_mas5]} {
      if {$x_max < [expr $max_x-4]} {
      	 incr x_min 5
         incr x_max 5
      }
   } elseif {![string compare $action x_menos5]} {
        if {$x_min > [expr $min_x+4]} {
           incr x_min -5
           incr x_max -5
   	}
     } elseif {![string compare $action x_mas1]} {
          if {$x_max < $max_x} {
             incr x_min 1
             incr x_max 1
          }
       } elseif {![string compare $action x_menos1]} {
            if {$x_min > $min_x} {
               incr x_min -1
               incr x_max -1
            }
         } elseif {![string compare $action y_mas5]} {
              if {$y_max < [expr $max_y-4]} {
                 incr y_min 5
                 incr y_max 5
              }
           } elseif {![string compare $action y_menos5]} {
                if {$y_min > [expr $min_y+4]} {
                   incr y_min -5
                   incr y_max -5
                }
             } elseif {![string compare $action y_mas1]} {
                  if {$y_max < $max_y} {
                     incr y_min 1
                     incr y_max 1
                  }
               } elseif {![string compare $action y_menos1]} {
                    if {$y_min > $min_y} {
                       incr y_min -1
                       incr y_max -1
                    }
                 } elseif {![string compare $action z_mas5]} {
                      if {$z_max < [expr $max_z-4]} {
                         incr z_min 5
                    	 incr z_max 5                    	
                      } 
                    } elseif {![string compare $action z_menos5]} {
                    	 if {$z_min > [expr $min_z+4]} {
                    	    incr z_min -5
                    	    incr z_max -5
                    	 }
                      } elseif {![string compare $action z_mas1]} {
                      	   if {$z_max < $max_z} {
                     	      incr z_min 1
                     	      incr z_max 1
                      	   }
                      	} elseif {![string compare $action z_menos1]} {
                      	     if {$z_min > $min_z} {
                      	     	incr z_min -1
                      	     	incr z_max -1
                      	     }
                      	  } elseif {![string compare $action w_mas5]} {
                               if {$w_max < [expr $max_w-4]} {
                                  incr w_min 5
                    	          incr w_max 5                    	
                               }
                            } elseif {![string compare $action w_menos5]} {
                    	         if {$w_min > [expr $min_w+4]} {
                    	            incr w_min -5
                    	            incr w_max -5
                    	         }
                              } elseif {![string compare $action w_mas1]} {
                      	           if {$w_max < $max_w} {
                     	              incr w_min 1
                     	              incr w_max 1
                      	           }
                      	        } elseif {![string compare $action w_menos1]} {
                      	             if {$w_min > $min_w} {
                      	     	        incr w_min -1
                      	     	        incr w_max -1
                      	     	     }
                      	     	  }
   for {set i $x_min} {$i < $x_max} {incr i 1} {
      .$win.fr0.fr1.xlb[expr $i-$x_min] configure -text $i
   }
   for {set i $y_min} {$i < $y_max} {incr i 1} {
      .$win.fr0.fr1.ylb[expr $i-$y_min] configure -text $i
   }
   for {set i $z_min} {$i < $z_max} {incr i 1} {
      .$win.fr0.fr0.b[expr $i-$z_min] configure -text $i
   }
   for {set i $w_min} {$i < $w_max} {incr i 1} {
      .$win.fr0.fr4.b[expr $i-$w_min] configure -text $i
   }   
   for {set j $y_min} {$j < $y_max} {incr j 1} {
      for {set i $x_min} {$i < $x_max} {incr i 1} {
         set vt_e([expr $i-$x_min],[expr $j-$y_min]) $matrix_backup($i,$j,$z_index,$w_index)
     }
   }
}

proc eventos_change_table_4 {win action} {
   global min_x
   global max_x
   global min_y
   global max_y
   global min_z
   global max_z
   global min_w
   global max_w
   global x_min
   global x_max
   global y_min
   global y_max
   global z_min
   global z_max
   global w_min
   global w_max
   global z_index
   global w_index
   global matrix_backup
   global vt_e
   if {![string compare $action z_bcm_0]} {
      cambiar_matrix_4 $win 1 0
   } elseif {![string compare $action z_bcm_1]} {
        cambiar_matrix_4 $win 1 1
     } elseif {![string compare $action z_bcm_2]} {
          cambiar_matrix_4 $win 1 2
       } elseif {![string compare $action z_bcm_3]} {
            cambiar_matrix_4 $win 1 3
         } elseif {![string compare $action z_bcm_4]} {
              cambiar_matrix_4 $win 1 4            
           } elseif {![string compare $action w_bcm_0]} {
                cambiar_matrix_4 $win 2 0
             } elseif {![string compare $action w_bcm_1]} {
                  cambiar_matrix_4 $win 2 1
               } elseif {![string compare $action w_bcm_2]} {
                    cambiar_matrix_4 $win 2 2
                 } elseif {![string compare $action w_bcm_3]} {
                      cambiar_matrix_4 $win 2 3
                   } elseif {![string compare $action w_bcm_4]} {
                        cambiar_matrix_4 $win 2 4
                     } elseif {![string compare $action Aceptar]} {
           	          cambiar_matrix_4 $win 0 -1
                          enviar_matrix_4
                          destroy .$win
                          unset min_x
                          unset max_x
                          unset min_y
                          unset max_y
                          unset min_z
                          unset max_z
                          unset min_w
                          unset max_w
                          unset x_min
                          unset x_max
                          unset y_min
                          unset y_max
                          unset z_min
                          unset z_max
                          unset w_min
                          unset w_max
                          unset z_index
                          unset w_index
                          unset matrix_backup
                          unset vt_e
                       } elseif {![string compare $action Aplicar]} {
             	            cambiar_matrix_4 $win 0 -1
                            enviar_matrix_4
                         } elseif {![string compare $action Cancelar]} {
                              destroy .$win
                              unset min_x
                              unset max_x
                              unset min_y
                              unset max_y
                              unset min_z
                              unset max_z
                              unset min_w
                              unset max_w
                              unset x_min
                              unset x_max
                              unset y_min
                              unset y_max
                              unset z_min
                              unset z_max
                              unset w_min
                              unset w_max
                              unset z_index
                              unset w_index
                              unset matrix_backup
                              unset vt_e
                           }
}

proc cambiar_matrix_4 {win tc b_i} {
   global x_min
   global x_max
   global y_min
   global y_max
   global z_min
   global z_max
   global w_min
   global w_max
   global z_index
   global w_index
   global matrix_backup
   global vt_e
   for {set j $y_min} {$j < $y_max} {incr j 1} {
      for {set i $x_min} {$i < $x_max} {incr i 1} {
         set matrix_backup($i,$j,$z_index,$w_index) [.$win.fr0.fr1.e([expr $i-$x_min]+[expr $j-$y_min]) get]
      }
   }
   if {$tc != 0} {
      if {$tc == 1} {
         set z_index [.$win.fr0.fr0.b$b_i cget -text]
      } elseif {$tc == 2} {
         set w_index [.$win.fr0.fr4.b$b_i cget -text]
        }
      .$win.fr0.fr1.lb0 configure -text "$win $z_index $w_index"
      for {set j $y_min} {$j < $y_max} {incr j 1} {
         for {set i $x_min} {$i < $x_max} {incr i 1} {
            set vt_e([expr $i-$x_min],[expr $j-$y_min]) $matrix_backup($i,$j,$z_index,$w_index)
         }
      }
   }
}

proc enviar_matrix_4 {} {
   global min_x
   global max_x
   global min_y
   global max_y
   global min_z
   global max_z
   global min_w
   global max_w
   global matrix_backup
   for {set l $min_w} {$l < $max_w} {incr l 1} {
      for {set k $min_z} {$k < $max_z} {incr k 1} {
         for {set j $min_y} {$j < $max_y} {incr j 1} {
      	    for {set i $min_x} {$i < $max_x} {incr i 1} {
# Estas lineas estan momentaneamente hasta conectar la ventana a Nsl3.0
      	       set str "envio ($i,$j,$k,$l) $matrix_backup($i,$j,$k,$l)"
      	       puts $str
      	    }
         }
      }
   }
}