/* SCCS  @(#)nsl_nsl_file_stream_library.h	1.1---95/08/13--23:38:36 */
//
// nsl_nsl_file_stream_library.h
//

extern nsl_file& operator>>(nsl_file&,unsigned char&);
extern nsl_file& operator<<(nsl_file&,unsigned char&);
extern nsl_file& operator>>(nsl_file&,char&);
extern nsl_file& operator<<(nsl_file&,char&);
extern nsl_file& operator>>(nsl_file&,char*);
extern nsl_file& operator<<(nsl_file&,char*);
extern nsl_file& operator>>(nsl_file&,int&);
extern nsl_file& operator<<(nsl_file&,int&);
extern nsl_file& operator>>(nsl_file&,float&);
extern nsl_file& operator<<(nsl_file&,float&);
extern nsl_file& operator>>(nsl_file&,double&);
extern nsl_file& operator<<(nsl_file&,double&);

extern nsl_nsl_file& operator<<(nsl_nsl_file&,char*);
/*
template<class NslNumType, int NslTypeId>
extern istream& operator>>(istream&,nsl_num_0<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern istream& operator>>(istream&,nsl_num_1<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern istream& operator>>(istream&,nsl_num_2<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern ostream& operator<<(ostream&,nsl_num_0<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern ostream& operator<<(ostream&,nsl_num_1<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern ostream& operator<<(ostream&,nsl_num_2<NslNumType,NslTypeId>&);
*/

template<class NslNumType, int NslTypeId>
istream& operator>>(istream& in,nsl_num_0<NslNumType,NslTypeId>& layer)
{
	in >> layer.elem();
 
	return in;
}
template<class NslNumType, int NslTypeId>
istream& operator>>(istream& in,nsl_num_1<NslNumType,NslTypeId>& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();

	for (int i = i0; i <= i1; i++)
		in >> layer[i];
 
	return in;
}
template<class NslNumType, int NslTypeId>
istream& operator>>(istream& in,nsl_num_2<NslNumType,NslTypeId>& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();
	int j0 = layer.get_j0();
	int j1 = layer.get_j1();

	for (int i = i0; i <= i1; i++)
	    for (int j = j0; j <= j1; j++)
		in >> layer[i][j];
 
	return in;
}
template<class NslNumType, int NslTypeId>
ostream& operator<<(ostream& out,nsl_num_0<NslNumType,NslTypeId>& layer)
{
	out << layer.elem();
 
	return out;
}
template<class NslNumType, int NslTypeId>
ostream& operator<<(ostream& out,nsl_num_1<NslNumType,NslTypeId>& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();

	for (int i = i0; i <= i1; i++)
		out << layer[i];
 
	return out;
}
template<class NslNumType, int NslTypeId>
ostream& operator<<(ostream& out,nsl_num_2<NslNumType,NslTypeId>& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();
	int j0 = layer.get_j0();
	int j1 = layer.get_j1();

	for (int i = i0; i <= i1; i++)
	    for (int j = j0; j <= j1; j++)
		out << layer[i][j];
 
	return out;
}
