/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_comp_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_2<NslNumType,NslTypeId>_comp_library.h
//
/*
extern	int 		operator>(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	int 		operator<(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	int 		operator>(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator<(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator>(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator<(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator>(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator<(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);

extern	int 		operator>=(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	int 		operator<=(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	int 		operator>=(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator<=(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator>=(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator<=(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator>=(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator<=(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);

extern	int 		operator==(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	int 		operator!=(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	int 		operator==(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator!=(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator==(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator!=(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	int 		operator==(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	int 		operator!=(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
*/

// comparator

template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_2<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] > b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_2<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] > b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_2<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] > b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_2<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_2<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_2<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a > b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a > b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a > b[i][j])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a < b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a < b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a < b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_2<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] > b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_2<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] < b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a > b[i][j])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a < b[i][j])
			return 1;
	return 0;
}

// >=,<=

template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_2<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] >= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_2<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] >= b)
			return 1;
	return 0;
}template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_2<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] >= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_2<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_2<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_2<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a >= b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a >= b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a >= b[i][j])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a <= b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a <= b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator<=(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a <= b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_2<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] >= b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_2<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] <= b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator>=(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a >= b[i][j])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator<=(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a <= b[i][j])
			return 1;
	return 0;
}

// ==, !=

template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_2<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] == b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_2<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] == b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_2<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] == b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_2<NslNumType,NslTypeId>& a, const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_2<NslNumType,NslTypeId>& a, const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_2<NslNumType,NslTypeId>& a, const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a == b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a == b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a == b[i][j])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a != b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a != b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator!=(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a != b[i][j])
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_2<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] == b)
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_2<NslNumType,NslTypeId>& a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a[i][j] != b)
			return 1;
	return 0;
}
template<class NslNumType, int NslTypeId>
int operator==(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a == b[i][j])
			return 1;
	return 0;
}

template<class NslNumType, int NslTypeId>
int operator!=(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = b.get_imax();
	int ajmax = b.get_jmax();

	for(int i = 0; i < aimax; i++)
	    for(int j = 0; j < ajmax; j++)
		if(a != b[i][j])
			return 1;
	return 0;
}


