/* SCCS  @(#)nsl_vec_to_mat_library.C	1.1---95/08/13--20:48:17 */
//
//	nsl_vec_to_mat_library.C
//
/*
# include "nsl_all_kernel_include.h"

nsl_matrix nslExpand(const nsl_matrix& ref,const nsl_vector& a) // NSLvec_to_mat
{
	int vec_type = a.get_vec_type();

	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_matrix c(simax,sjmax);
	
	if (vec_type == 0) // row vector
	{
	    if (s != sjmax)
	    {
		cmd_error("*** nslExpand ***");
		cmd_error("vector jmax: ",s);
		cmd_error("matrix jmax: ",sjmax);
		cmd_error("Bad vector size");
		return c;
	    }

	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    c[i][j] = a[j];
	}
	if (vec_type == 1) // col vector
	{
	    if (s != simax)
	    {
		cmd_error("*** NSLvec_to_mat ***");
		cmd_error("vector imax: ",s);
		cmd_error("matrix imax: ",simax);
		cmd_error("Bad vector size");
		return c;
	    }

	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    c[i][j] = a[i];
	}

	return c;
}

nsl_matrix nslExpandRows(const nsl_matrix& ref,const nsl_vector& a) // NSLrow_vec_to_mat
{
	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_matrix c(simax,sjmax);

	if (s != sjmax)
	{
		cmd_error("*** nslExpandRows ***");
		cmd_error("vector jmax: ",s);
		cmd_error("matrix jmax: ",sjmax);
		cmd_error("Bad vector size");
		return c;
	}

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[j];

	return c;
}

nsl_matrix nslExpandCols(const nsl_matrix& ref,const nsl_vector& a) // NSLcol_vec_to_mat
{ 
	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_matrix c(simax,sjmax);

	if (s != simax)
	{
		cmd_error("*** nslExpandCols ***");
		cmd_error("vector imax: ",s);
		cmd_error("matrix imax: ",simax);
		cmd_error("Bad vector size");
		return c;
	}

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[i];

	return c; 
}

nsl_matrix nslExpandRows(const nsl_vector& a,const int simax) // NSLrow_vec_to_mat
{
	int sjmax = a.get_imax();

	nsl_matrix c(simax,sjmax);

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[j];

	return c;
}

nsl_matrix nslExpandCols(const nsl_vector& a,const int sjmax) // NSLcol_vec_to_mat
{
	int simax = a.get_imax();

	nsl_matrix c(simax,sjmax);
	
	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[i];

	return c;
}
*/