# Plantilla para los desplegados graficos de NSL

proc canvas_manager {plantilla} {
   catch {destroy $plantilla}
   toplevel $plantilla
   wm geometry $plantilla 600x620
   focus $plantilla

   menu $plantilla.menu -tearoff 0
   # Se crea el primer item de la barra de mens
   set m $plantilla.menu.m_frame
   menu $m -tearoff 0
   $plantilla.menu add cascade -label "Frame" -menu $m -underline 0
   $m add command -label "New Canvas" -command variables
   $m add command -label "Remove Canvas"
   $m add separator
   $m add command -label "Columns"
   $m add command -label "Frame Options"
   $m add command -label "Frame Print"
   $m add separator
   $m add command -label "Close" -command "destroy $plantilla"

   # Se crea el segundo item de la barra de mens
   set m $plantilla.menu.m_canvas
   $plantilla.menu add cascade -label "Canvas" -menu $m -underline 0
   menu $m -tearoff 0
   $m add command -label "Zoom"
   $m add command -label "Change Type"
   $m add command -label "Canvas Options"
   $m add command -label "Canvas Print"
   $m add command -label "Export Data"

   # Se crea el tercer item de la barra de mens
   set m $plantilla.menu.m_help
   $plantilla.menu add cascade -label "Help" -menu $m -underline 0
   menu $m -tearoff 0

   $plantilla configure -menu $plantilla.menu 

   frame $plantilla.fr0
   pack $plantilla.fr0 -side bottom -fill x

   label $plantilla.fr0.lb0 -text " End Cycle time:     "
   label $plantilla.fr0.lb1 -text "        "
   label $plantilla.fr0.lb2 -text " Finished Cycles:    "
   label $plantilla.fr0.lb3 -text "        "
   label $plantilla.fr0.lb4 -text " Finished Epochs:    "
   label $plantilla.fr0.lb5 -text "        "

   pack $plantilla.fr0.lb0 -side left
   pack $plantilla.fr0.lb1 -side left
   pack $plantilla.fr0.lb2 -side left
   pack $plantilla.fr0.lb3 -side left
   pack $plantilla.fr0.lb4 -side left
   pack $plantilla.fr0.lb5 -side left
}

#canvas_manager .nsl